///home/berryj/link/bin/genMethods "-g" "-t" "MDHyperGraph*" "-r" "MHyperGraph*" "-I" "LINK/graph/HyperGraph.h" "-I" "LINK/graph/DHyperGraph.h" "-y" "display_graphptr" "-m" "mark_graphptr" "-w" "free_graphptr" "-d" "graph" "-f" "___mDHyperGraph_" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/HyperGraph.h>

#include <LINK/graph/DHyperGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graphptr(SCM, SCM, int);
void mark_graphptr(SCM);
void free_graphptr(SCM);

typedef MDHyperGraph* _MDHyperGraph_;

#define _MDHyperGraph_DATA(x) ((MDHyperGraph**) (EXTDATA(x)))
#define _MDHyperGraph_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MDHyperGraph* >::type))
#define _MDHyperGraph_ISNT_DATA(x) (!_MDHyperGraph_IS_DATA(x))

#define _MDHyperGraph_CXX_DATA(x) (*(MDHyperGraph**) (EXTDATA(VAL(x))))
#define _MDHyperGraph_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MDHyperGraph* >::type))
#define _MDHyperGraph_CXX_ISNT_DATA(x) (!_MDHyperGraph_CXX_IS_DATA(x))


static SCM is_MDHyperGraph_(SCM i)
{
	if (_MDHyperGraph_CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init____mDHyperGraph_()
{
	Wrapper<_MDHyperGraph_>::type = STk_new_CXXwrapper_id(
			Wrapper<_MDHyperGraph_>::name, 
			Wrapper<MHyperGraph* >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graphptr,
			(void (*)(SCM x))mark_graphptr,
			(void (*)(SCM x))free_graphptr);
	Tcl_InitHashTable(&Register<_MDHyperGraph_>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("MDHyperGraph?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_MDHyperGraph_);
	return UNDEFINED;
}

void genExtra___mDHyperGraph_Methods(void);

PRIMITIVE STk_init_methods____mDHyperGraph_()
{
	genExtra___mDHyperGraph_Methods();
	return UNDEFINED;
}
